#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                        KaseCD Peak oscilator.mq4 |
//|                                    Copyright  2006, Yousky Soft |
//|                                            http://yousky.free.fr |
//|                                                                  |
//+------------------------------------------------------------------+
//| KaseCD_Peak_Oscilator_TRO_MODIFIED_VERSION                       |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
#property copyright " Jeremy Burt"
#property link      ""

#property indicator_separate_window
#property indicator_color1 Blue
#property indicator_buffers 2
#property indicator_color2 Red

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+

//+--------- TRO MODIFICATION ---------------------------------------+ 

extern bool   Sound.Alert    = true ;

extern double offset = 8;
extern double initial = 65;

//+--------- TRO MODIFICATION ---------------------------------------+ 
string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 

datetime Trigger ;

int OldBars = -1 ;

color tColor = Yellow ;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;
double ExtHistoBuffer[];
double ExtHistoBuffer2[];


//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{

   period       = Period() ;   
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;

   
   tShortName = symbol + tChartPeriod  ; 
   
   
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(0, ExtHistoBuffer);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(1, ExtHistoBuffer2);
   
   return(0);
}
int start()
{



//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
double RWH = 0;
double RWL = 0;
double PK = 0;
double kcd = 0;
double var1 = 0;
double var2 = 0;
double LN = 0;
double refL = 0;
double refH = 0;
double temp = 0;
double mn = 0;
double sd = 0;
double temp1 = 0;
double temp2 = 0;
double totalsd = 0;
double ctr = 1;
double mean = 1;
double sum = 0;
int shift = 0;
double dummy = 0;
double prevkcd = 0;

/*[[
	Name := KaseCD Peak oscilator
	Author := Jeremy Burt
	Separate Window := Yes
	First Color := Blue
	First Draw Type := Histogram
	First Symbol := 217
	Use Second Data := Yes
	Second Color := Red
	Second Draw Type := Line
	Second Symbol := 218
]]*/
   
   
 
 

// loop from first bar to current bar (with shift=0)
for(shift=Bars-1;shift>=0 ;shift--){ 
  mean=(High[shift]+Low[shift]+Close[shift])/3;
  sum += Close[0];
  ctr++;
} 



mean=sum/ctr;

for(shift=Bars-1;shift>=0 ;shift--)
{ 
    if( refL ==  Lowest(NULL, 0, MODE_LOW,offset,offset) ) dummy=shift ; else refL=Low[0];
    if( refH ==  Highest(NULL, 0, MODE_HIGH,offset,offset) )  dummy=shift ; else refH = High[0];
    if (iATR(NULL, 0, initial,shift) != 0)
    {
	    RWH = (High[0] - refH)/(iATR(NULL, 0, initial,shift)*MathSqrt(initial));
	    RWL = (Low[0]-refL)/(iATR(NULL, 0, initial,shift)*MathSqrt(initial));
	 }
    
	PK = iMA(NULL, 0, iMA(NULL, 0, initial, 0, RWH - RWL, PRICE_CLOSE, shift), 0, MODE_LWMA, PRICE_CLOSE, shift);
	kcd = PK - iMA(NULL, 0, PK, offset, MODE_EMA, PRICE_CLOSE, shift);
	
	sd = (mean - Close[0])/shift;
	
	if( (mn + 1.33*sd   > 2.08) )  var1 = mn+1.33*sd     ; else var1 = 2.08; 
	if( (mn - (1.33*sd) < -1.92 )) var2 = (mn-(1.33*sd)) ; else var2 = -1.92;
	
	
	if( prevkcd > kcd ) dummy = kcd ; else temp1 = 0;
	if( kcd > prevkcd ) dummy = kcd ; else temp2 = 0;
	
	prevkcd = kcd;
 
   ExtHistoBuffer[shift]  = dummy;
 
   ExtHistoBuffer2[shift] = kcd;
 
Comment(

"shift " , shift, "\n" ,
 
"") ; 
	 
 
} 





//+--------- TRO MODIFICATION ---------------------------------------+  
      
      if ( Trigger != Time[0] &&  Sound.Alert ) 
      {
        if( ExtHistoBuffer2[0] > ExtHistoBuffer2[1] && ExtHistoBuffer2[2] > ExtHistoBuffer2[1]) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " Kase bottomed "+ DoubleToStr(Close[0] ,digits)); }
        if( ExtHistoBuffer2[0] < ExtHistoBuffer2[1] && ExtHistoBuffer2[2] < ExtHistoBuffer2[1]) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " Kase peaked   "+ DoubleToStr(Close[0] ,digits)); }
   
      }



  return(0);
}



//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}



//+--------- TRO MODIFICATION ---------------------------------------+  

/*


Comment(


"ExtHistoBuffer2[0] " , DoubleToStr(ExtHistoBuffer2[0],Digits) , "\n" ,
"ExtHistoBuffer2[1] " , DoubleToStr(ExtHistoBuffer2[1],Digits) , "\n" , 
"ExtHistoBuffer2[2] " , DoubleToStr(ExtHistoBuffer2[2],Digits) , "\n" ,
"") ; 	

*/
	